<?php
/**
* @package asama
* @category include
*/
//--------------------------------------------------------------------------------
// studio hustlemouse
// PHP Code 'HustleClass.php'
// Create : 2021.12.16
// Modify : 2023.11.25
// Author : maruhiro
// (c)maruhiro all rights reserved.
//--------------------------------------------------------------------------------
// CORE CLASS
//--------------------------------------------------------------------------------
class HustleClass {
	//--------------------------------------------------------------------------------
	// CONSFIGURATION
	//--------------------------------------------------------------------------------
	private const INCLUDE_PATH = '/include/';
	//const CLASS_FILE_PREFIX = 'hustle';
	//const CLASS_FILE_SUFFIX = 'Class';
	//const PACKAGE_PREFIX = '';
	private const HOOK_CLASSES = ['RegistrationClass', 'AdministrationClass', 'ActivationClass'];
	//const ADMIN_PROCESSOR_PREFIX = 'Admin_Processor_';
	//const ADMIN_PROCS = array( 'setting', 'management' );
	//const CONTROLLER_SUFFIX = '_Controller';
	public $UTL;
	public $aspect_index = 0.707;
	//カスタム投稿タイプ名を格納する配列（空でもここでpublic宣言しないといかんかった）
	public $postHeads;
	public $postTypes;
	public $postTypeName = 'Feature';
	//配列型汎用プライベートプロパティ
	private $prps = array();
	/*** 以下のプロパティーはゲッターとセッターで運用する。ゲッターで運用するのでpublic扱いになる。***/
	//public $pageMode = '';//ページタイプ
	//public $achvType = '';//アーカイブズタイプ
	//public $pageSlg = '';//スラッグ
	//本テーマによる投稿開始日時を'Y-m-d H:i:s（MySQL の DATETIME フォーマット）'にて表記する。
	//public $startDate = '2022-01-24 00:00:00';
	//public $hustleTagCloud = '';
	/* public $GoogleParams = array(
	'GooglMapsKEY'=>'',
	'GooglMapsID'=>'',
	); */
	//public $hustleCrumb = '';
	//public $customPost = false;
	//public $thumbnailToRss = false;
	/*** 以下のプロパティーは名前で参照して運用する。***/
	//確実な動作のためにスタイルシートはフォント→アニメーション→デザインの順番で読み込まれるように列記する。
	//ブログページ
	private $currentFonts = array(
	'google_MaterialIcons'=>'https://fonts.googleapis.com/icon?family=Material+Icons',
	'google_SourceCodePro'=>'https://fonts.googleapis.com/css2?family=Source+Code+Pro:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap',
	'google_NotoSans'=>'https://fonts.googleapis.com/css2?family=Noto+Sans:ital,wght@0,400;0,700;1,400;1,700&display=swap',
	'google_NotoSansJP'=>'https://fonts.googleapis.com/css2?family=Noto+Sans+JP:wght@100;300;400;500;700;900&display=swap',
	);
	private $parentStyles = array('hustle-font'=>'/css/font.css',);
	private $currentStyles = array(
	//'hustle-animation'=>'/css/asama_anim.css',
	'hustle-design' =>'/css/asama.css',
	);
	private $currentScripts = array(
	'hustle-script'=>'/js/hustleConfig.js',
	);
	//投稿編集ページ
	private $editorFonts = array(
	'google_SourceCodePro'=>'https://fonts.googleapis.com/css2?family=Source+Code+Pro:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap',
	'google_NotoSans'=>'https://fonts.googleapis.com/css2?family=Noto+Sans:ital,wght@0,400;0,700;1,400;1,700&display=swap',
	'google_NotoSansJP'=>'https://fonts.googleapis.com/css2?family=Noto+Sans+JP:wght@100;300;400;500;700;900&display=swap',
	'google_Quicksand'=>'https://fonts.googleapis.com/css2?family=Quicksand:wght@300;400;500;600;700&display=swap',
	'google_KiwiMaru'=>'https://fonts.googleapis.com/css2?family=Kiwi+Maru:wght@300;400;500&display=swap',
	);
	private $editorStyles = array(
		'hustle-editor'=>'/css/postEdit.css',
	);
	//--------------------------------------------------------------------------------
	// CONSTRUCTOR（戻り値は設定できない。）
	//--------------------------------------------------------------------------------
	public function __construct() {}
	//自信のクラス名をマジックメソッドで返す。
	public static function who() {return __CLASS__;}
	//--------------------------------------------------------------------------------
	// INITIALIZE
	//--------------------------------------------------------------------------------
	public function init() {
		//タイムゾーンセット（不安な設定）
		//date_default_timezone_set( 'Asia/Tokyo' );
		//Built-Inプラグインのロード
		//include_once( TEMPLATEPATH.'/lib/acf/acf.php' );
		//include_once( TEMPLATEPATH.'/lib/acf-repeater/acf-repeater.php' );
		require_once(TEMPLATEPATH.self::INCLUDE_PATH.'tool/UtilityClass.php');
		//初期化の始まる前に'UtilityClass'の参照を容易にしておく。ログ出力の'echo'も使えるようになる。
		$this->UTL = 'UtilityClass';
		foreach(self::HOOK_CLASSES as $nm) {
			require_once(TEMPLATEPATH.self::INCLUDE_PATH.'stuff/'.$nm.'.php');
		}
		//クラスファイルのAutoLoad（テスト中）
		//spl_autoload_register(array($this, 'autoload'));
		$this->orderEnqueueScripts('parentStyles');
		//asamaテーマが有効化された場合
		if(get_template() === get_stylesheet()) {
			$this->orderEnqueueScripts('currentFonts');
			$this->orderEnqueueScripts('currentStyles');
			$this->setThePageSpecial('<p class="message"><span class="attention">THE PAGE SPECIAL!</span></p>');
			//$this->setTheContentSpecial('<p class="message"><span class="attention">THE CONTENT SPECIAL!</span></p>');
			//the copyright for 'asama'
			$this->setTheCopyright('2021.11.15〜 developed by hustlemouse, asama & asamit themes are open source code. <br>Author : maruhiro (Coded with HTML5 + ES6 + PHP8)±');
		}
		$this->orderEnqueueScripts('currentScripts');
		$this->orderEnqueueScripts('editorFonts');
		$this->orderEnqueueScripts('editorStyles');
		//各種フックの登録（読み込んだクラスファイルの初期化）
		$this->bindHook(self::HOOK_CLASSES);
		//管理画面の処理
		//$this->admin_process(self::ADMIN_PROCS);
		//コントローラーのルーティング
		//$this->route_controller();
	}
	//--------------------------------------------------------------------------------
	// ECHO
	//--------------------------------------------------------------------------------
	public function echo($str) {$this->UTL::echoo($str);}
	public function echoo($str) {$this->UTL::echoo($str);}
	//--------------------------------------------------------------------------------
	// GETTER AND SETTER
	//--------------------------------------------------------------------------------
	//マジックメソッド
	public function __get($key){return $this->get($key);}
	public function __set($key,$vlu){$this->set($key,$vlu);}
	//配列型汎用プロパティのゲッター
	public function get(string $key) {
		if(array_key_exists($key, $this->prps)) {
			return $this->prps[$key];
		} else {
			//$this->echoo("PROPERTY_>{$key}_UNDEFINDE");
			return 'UNDEFINDE';
		}
	}
	//配列型汎用プロパティのセッター
	public function set(string $key, $vlu) {
		if(!array_key_exists($key, $this->prps)) {
			//$this->echoo("PROPERTY_>{$key}_HAS_BEEN_MADE");
		}
		$this->prps[$key] = $vlu;
	}
	//--------------------------------------------------------------------------------
	// AUTO LOAD
	//--------------------------------------------------------------------------------
	// オートロード（spl_autoload_registerのコールバック）
	public function autoload($class) {
		//$this->echoo("IS_A_CLASS_>{$class}");
	}
	//--------------------------------------------------------------------------------
	// HOOKS
	//--------------------------------------------------------------------------------
	// フッククラス群の生成と初期化をして、その後はアクセスしない。
	public function bindHook($hooks) {
		foreach($hooks as $class) {
			if (class_exists($class)) {
				$instance = new $class($this);
				if (method_exists($instance, 'init')) {
					$instance->init();
				}
			}
		}
	}
	//--------------------------------------------------------------------------------
	// ORDERING $ HANDOUT SCRIPTS
	//--------------------------------------------------------------------------------
	public function orderEnqueueChildStyles($arr) {
		$this->currentStyles = $arr;
		$this->orderEnqueueScripts('currentStyles');
	}
	public function orderchildFonts($arr) {
		$this->currentFonts = $arr;
		$this->orderEnqueueScripts('currentFonts');
	}
	public function orderEnqueueScripts($key) {
		if(property_exists($this, $key)) {
			foreach($this->$key as $k=>$v) {
				$uri = '';
				switch($key) {
					case 'parentStyles':
					case 'editorStyles':
						//親テーマのディレクトリ取得はget_template_directory_uri()で取得する。
						$uri = get_template_directory_uri();
						break;
					case 'currentStyles':
					case 'currentScripts':
						//カレントテーマ（親テーマもしくは子テーマ）のディレクトリ取得はget_stylesheet_directory_uri()で取得する。
						$uri = get_stylesheet_directory_uri();
						break;
					case 'currentFonts':
					case 'editorFonts':
					default:
				}
				$this->$key[$k] = $uri.$v;
			}
		}
	}
	public function tugEnqueueScripts($key):array {
		if(property_exists($this, $key)) return $this->$key;
		else return [];
	}
	//--------------------------------------------------------------------------------
	// START DATE OF THIS THEME
	//--------------------------------------------------------------------------------
	//当該テーマの運用開始日時を設定する。
	public function setAtTheThenePostDate($s) {$this->startDate = $s;}
	//投稿日と当該テーマの運用開始日時（$startDate）のUTCフォーマット数値の比較で真偽を返す。
	//当該テーマの運用開始日時以降であれば真、以前であれば偽となる。
	public function isTheThemePost($postTime) {
		$at = new DateTime($this->startDate, new DateTimeZone(wp_timezone_string()));
		$at = $at->format('U');
		$pt = new DateTime($postTime, new DateTimeZone(wp_timezone_string()));
		$pt = $pt->format('U');
		return $pt>=$at;
	}
	//--------------------------------------------------------------------------------
	// HUSTLE_TAG_CLOUD
	//--------------------------------------------------------------------------------
	public function setHustleTagCloud($s) {$this->hustleTagCloud = $s;}
	public function isHustleTagCloud() {return $this->hustleTagCloud!=='UNDEFINDE'? true:false;}
	//--------------------------------------------------------------------------------
	// HUSTLE_BREAD_CRUMB
	//--------------------------------------------------------------------------------
	public function setHustleCrumb($s) {$this->hustleCrumb = $s;}
	public function isHustleCrumb() {return $this->hustleCrumb!=='UNDEFINDE'? true:false;}
	//--------------------------------------------------------------------------------
	// GOOGLE_MAPS
	//--------------------------------------------------------------------------------
	public function setGoogleParams($arr) {
		$this->GoogleParams= array('GooglMapsKEY'=>$arr['KEY'], 'GooglMapsID'=>$arr['ID'],);
	}
	public function putGoogleParams() {
		if($this->GoogleParams) {
			echo '<script>GoogleParams = '.json_encode($this->GoogleParams).'</script>';
		}
	}
	//--------------------------------------------------------------------------------
	// SET_CHILD_THEME_CONTENTS
	//--------------------------------------------------------------------------------
	public function setThePageSpecial($str) {
		if(strlen($str) > 0) $this->pageSpecial = $str;
	}
	public function setTheCopyright($str) {
		if(strlen($str) > 0) $this->copyright = $str;
	}
	//--------------------------------------------------------------------------------
	// REGISTER_PAGE_MODE_&_ARCHIVES_TYPE
	//--------------------------------------------------------------------------------
	public function rgstPageAspects($pm, $at) {
		$this->pageMode = $pm;
		$this->achvType = $at;
	}
	public function theMode() {return $this->pageMode;}
	public function theAchvType() {return $this->achvType;}
	//--------------------------------------------------------------------------------
	// REGISTER_CUSTOME_POST_TYPE
	//--------------------------------------------------------------------------------
	public function setCreatePostType($b) {
		$this->customPost = $b;
		//セッターを使って配列の生成ができると思っていたが、なぜか？この空宣言ケースではPublicにできなかった。よって事前に宣言している。
		if($b) {
			$this->postHeads = [];
			$this->postTypes = [];
		}
	}
	public function isHustlePostType() {
		if($this->customPost!=='UNDEFINDE') return $this->customPost;
		else return false;
	}
	public function getHustlePostType() {
		return $this->postTypes;
	}
	public function rgstCustomPostType($arr) {
		if($this->customPost) $this->rgstPostType = $arr;
	}
	public function rgstCustomTaxonomy($arr) {
		if($this->customPost) $this->rgstTaxonomy = $arr;
	}
	//--------------------------------------------------------------------------------
	// ADD EYECATCH IMAGE ROR RSS //20231125 maruhiro
	//--------------------------------------------------------------------------------
	public function addThumbnailForRss($b) {
		$this->thumbnailForRss = $b;
	}
}