/*************************************************************
studio hustlemouse
Javascript Code 'hustleConfig.js'
Create : 2021.11.30
Modify : 2023.9.10
Author : maruhiro
(c)maruhiro all rights reserved.
*************************************************************/
//----------------------------------------------------------------
// OUTLINE
// [GLOVAL FIELDS]
// [HUSTLE FIELDS]
// [METHODS]
//----------------------------------------------------------------
// STRICT MODE（厳格モード）
'use strict';
//----------------------------------------------------------------
// CONFIGURATION
//----------------------------------------------------------------
let hustle = new Object();
if(typeof asama === 'undefined') {
	//最初の環境設定として本スクリプトがロードされる場合の処理。
	console.log('BASE_OBJECT_"asama"_IS_>false');
	//WORKING ON SOME SERVICE
	hustle.onService = false;
	//PROJECT DIRECTORY NAME
	hustle.project = 'myProject';
} else {
	//Wordpressテーマ「あさま」の「header.php」ソース内のヘッダーで生成される「asama」オブジェクトが存在した場合の処理。
	console.log('BASE_OBJECT_"asama"_IS_>true');
	//WORKING ON SOME SERVICE
	hustle.onService = true;
	//THEME DIRECTORY URI
	hustle.dirUri = asama.dirUri;
	//WORDPRESS DIRECTORY NAME
	hustle.dirWP = asama.dirWP;
	//THEME DIRECTORY NAME
	hustle.project = asama.project;
}
hustle.PU;
hustle.BU;
hustle.MAIN;
//----------------------------------------------------------------
//STYLE SHEET
//デザイン・アニメーションCSSファイル名の指定
hustle.designCss = 'asama.css';
hustle.animCss = 'asama_anim.css';
//デザイン・アニメーションCSS指定項目配列
hustle.dsgnRules;
hustle.animRules;
//----------------------------------------------------------------
//COOKIE NAME
//テキストサイズ指定値を格納するクッキー名
hustle.textSizeCookie = 'textSize';
//----------------------------------------------------------------
//ウインドウ名（ページタイトルでなくウインドウオブジェクトの参照名）
hustle.windowName = hustle.project;
//参照基準となるディレクトリ名
hustle.baseDirName = hustle.project;
//----------------------------------------------------------------
hustle.re = new RegExp('\\?', 'g');
hustle.uri = '';
hustle.param = '';
hustle.tmp = location.href.search(hustle.re);
if(hustle.tmp === -1) {
	hustle.uri = location.href.slice(0);
} else {
	hustle.uri = location.href.slice(0, hustle.tmp);
	hustle.param = location.href.slice(hustle.tmp+1);
}
console.log(`URI_>${hustle.uri}_PARAM_${hustle.param}`);
//----------------------------------------------------------------
// REGIST CODEBASE
if(hustle.onService) {
	console.log(`DIRURI_>${hustle.dirUri}_DIRWP_>${hustle.dirWP}_PROJECT_>${hustle.project}`);
	// hustle.pathCMS = `${hustle.dirWP}/wp-content/themes/`;
	// hustle.tmp = `${hustle.uri.split('//')[0]}//${hustle.uri.split('//')[1].split('/')[0]}/`;
	// hustle.CB = `${hustle.tmp}${hustle.pathCMS}${hustle.baseDirName}/`;
	hustle.CB = `${hustle.dirUri}/`;
} else {
	hustle.CB = '';
	//読み込みの都合でここでコードベースを取る方が便利。利用クラス郡も生成時にこれを拾って利用。
	hustle.re = new RegExp(`${hustle.baseDirName}/.*$`, 'g');
	try {
		hustle.tmp = hustle.uri.match(hustle.re)[0];
	} catch(e) {
		console.log(`CATCH_ERROR_>${e.message}_>>>'baseDirName' has wrong value, may be.`);
	}
	hustle.re = new RegExp('/', 'g');
	hustle.re.exec(hustle.tmp);//1個目を検索しておく
	while(hustle.re.exec(hustle.tmp) !== null) hustle.CB += '../';
}
console.log(`CODEBASE_${hustle.CB}`);
//----------------------------------------------------------------
// URL PARAMETER INDEX
//URLパラメータをインデックスと値のセットオブジェクトにする。
if(hustle.param !== '') {
	hustle.tmp = new Object();
	hustle.param = hustle.param.split('&');
	hustle.param = hustle.param.map((cv, id, ar) => cv.split('='));
	hustle.param.forEach((cv, id, ar) => {hustle.tmp[cv[0]] = cv[1]});
	hustle.param = hustle.tmp;
	//for(let k of Object.keys(hustle.param)) console.log(`PARAM_KEY_>${k}_VALUE_>${hustle.param[k]}`);
}
//----------------------------------------------------------------
// REGISTRATION SOURCES
hustle.registJS = [
	`${hustle.CB}js/RegistrationClass.js`,
	`${hustle.CB}js/MainClass.js`,
	`${hustle.CB}js/tool/hustleBrowserUtilityClass.js`,
	`${hustle.CB}js/tool/hustlePageUtilityClass.js`,
	`${hustle.CB}js/tool/hustleWireFrameUtilityClass.js`
];
//----------------------------------------------------------------
// LOAD JAVASCRIPT FILES
for(let ps of hustle.registJS) {
	document.write(`<script type='text/javascript' src='${ps}'></script>`);
}
document.write(`<div id='whiteBoard'></div>`);
document.write(`<div id='workingAnim'></div>`);
//----------------------------------------------------------------
//GOOGLE MAPS CONFIG
try {
	hustle.GooglMapsKEY = GoogleParams.GooglMapsKEY;
	hustle.GooglMapsID = GoogleParams.GooglMapsID;
} catch(e) {
	console.log(`CATCH_ERROR_>${e.message}_>>>'Google Maps' are not in order, may be.`);
}
// REGIST GOOGLE MAPS
// グローバルスコープのあるオブジェクトでないと受信できないみたい。
function registGoogleMaps() {hustle.MAIN.letGoogleMaps();}
//----------------------------------------------------------------
// hustleの初期化メソッド
//Syntax:objectName.init();
//Parameter:なし
//Return:なし
//Reference:hustleの初期化メソッド
hustle.init = function () {
	hustle.PU = hustlePageUtilityClass;
	hustle.WFU = hustleWireFrameUtilityClass;
	hustle.BU = hustleBrowserUtilityClass;
	hustle.RG = new RegistrationClass();
	hustle.RG.init();
	window.name = hustle.windowName;
	window.focus();
};
//----------------------------------------------------------------
// ログ出力
//ブラウザのアラートダイアログを利用するかどうかの真偽値
hustle.ALERT = false;
hustle.CNSL = true;
hustle.msgNum = 0;
//----------------------------------------------------------------
//Syntax:objectName.echo(s, isError, ...arg);
//Parameter:"s"は文字列
//Parameter:"isError"はエラー出力にするかどうかの真偽値
//Parameter:"arg"はconsole.dir()で出力するための可変長変引数
//Return:なし
//Reference:ログを出力するメソッド
hustle.echo = function(s, isError=false, ...arg) {
	if (document.hustleWatcher) {
		// hustleWatcherオブジェクトが存在した場合、そちらにメッセージを送る
		if (isError) document.hustleWatcher.log.value = `error_${hustle.msgNum}_${s}\n${document.hustleWatcher.log.value}`;
		else document.hustleWatcher.log.value = `echo_${hustle.msgNum}_${s}\n${document.hustleWatcher.log.value}`;
	} else if (hustle.ALERT) {
		// アラートダイアログ利用が真の場合、alertメソッドを呼び出す（どうやらスマートフォンはアラートが無いらしい）
		if(isError) window.alert(`Sorry! This is not ALERT, Just TESTING.\n--------------------------------------\nERROR!_${hustle.msgNum}\n${s}\n--------------------------------------`);
		else window.alert(`Sorry! This is not ALERT, Just TESTING.\n--------------------------------------\nECHO_${hustle.msgNum}\n${s}\n--------------------------------------`);
	} else if(hustle.CNSL) {
		if(isError) console.error(`error_${hustle.msgNum}_${s}`);
		else console.log(`echo_${hustle.msgNum}_${s}`);
		if(arg!==undefined) {
			arg.forEach((vc,id,ar)=>console.dir(vc));
		}
	}
	hustle.msgNum++;
};
//----------------------------------------------------------------
// hustleの初期化実装メソッド
//Syntax:objectName.addLoadEvent(init);
//Parameter:"init"は初期化メソッド
//Return:なし
//Reference:ページのonloadイベントを損なうことなく、hustleオブジェクトの初期化メソッドを実装するためのメソッド
hustle.addLoadEvent = function (init) {
	// onloadイベントを変数pageOnloadに代入する
	hustle.pageOnload = window.onload;
	// onload時に呼び出されるメソッドが無ければhustleオブジェクトのinitメソッドをonload時の呼び出しメソッドとして採用する
	if (typeof(window.onload) !== 'function') window.onload = init;
	else {
		// onload時に呼び出されるメソッドがあったならば、onload時に
		window.onload = function () {
			// 変数pageOnloadに代入したメゾッドを呼び出し
			hustle.pageOnload();
			// 続いてhustleオブジェクトのinitメゾッドを呼び出す
			this.init();
		};
	}
};
//----------------------------------------------------------------
// EVENT INCREMENT
//onloadイベント発生時に、hustleオブジェクトの初期化メソッドを実装する。
if (document.getElementById) hustle.addLoadEvent(hustle.init);
