/****************************************************************
studio hustlemouse
JavaScript Code 'hustleBrowserUtilityClass'
Author MARUHIRO
Create:2021.1.30
Modify:2021.9.21
(c)maruhiro all rights reserved.
Special Thanks
Sato Yutaro, Miguel Sanchez
****************************************************************/
class hustleBrowserUtilityClass {
	//----------------------------------------------------------------
	// CONSTRACTOR
	//----------------------------------------------------------------
	constructor() {}
//----------------------------------------------------------------
// GET WINDOW INFORMATION
//----------------------------------------------------------------
	// GET INNER SIZE
	//----------------------------------------------------------------
	//Syntax:hustlePageUtilityClass.getInnerSize({obj});
	//Parameter:'obj'はウインドウオブジェクト
	//Return:配列
	//Reference:ウインドウオブジェクトの内側のサイズ情報を配列にまとめて返す。
	static getInnerSize({obj}) {
		let r = new Array();
		//iPhoneでもiPadでも縦正位置だとwindow.orientationの値が0になりfalseになるので条件とした。
		if ('orientation' in obj) {
			//if(obj.orientation || hustle.RG.IOS) {
			if (Math.abs(obj.orientation / 90) !== 1) {
				//hustle.echo('WINDOW_ROTATED_VERTICAL_'+obj.orientation+'_'+obj.innerWidth+'_'+obj.innerHeight, false);
				if (obj.innerWidth > obj.innerHeight) {
					r = [obj.innerHeight, obj.innerWidth];
				} else {
					r = [obj.innerWidth, obj.innerHeight];
				}
			} else {
				//hustle.echo('WINDOW_ROTATED_HORIZONTAL_'+obj.orientation+'_'+obj.innerWidth+'_'+obj.innerHeight, false);
				if (obj.innerWidth > obj.innerHeight) {
					r = [obj.innerWidth, obj.innerHeight];
				} else {
					r = [obj.innerHeight, obj.innerWidth];
				}
			}
		} else {
			//hustle.echo('WINDOW_SIZE_'+obj.innerWidth+'_'+obj.innerHeight, false);
			r = [obj.innerWidth, obj.innerHeight];
		}
		return r;
	}
//----------------------------------------------------------------
// ORGANIZE COOKIE（未検証）
//----------------------------------------------------------------
	//Syntax:hustlePageUtilityClass.putCookie({vlu, dys, n});
	//Parameter:'vlu'はCookieに格納する値
	//Parameter:'dys'はCookieの保管期限日数
	//Parameter:'n'はCookieの名前
	//Reference:Cookieに情報を格納する
	static putCookie({vlu, dys, n}) {
		let exp = '';
		if (dys) {
			let date = new Date();
			date.setTime(date.getTime() + (dys * 24 * 60 * 60 * 1000));
			exp = ';expires=' + date.toGMTString();
		}
		document.cookie = n + '=' + vlu + exp + ';path=/';
	}
	//----------------------------------------------------------------
	//Syntax:hustlePageUtilityClass.getCookie({n});
	//Parameter:'n'はCookieの名前
	//Reference:Cookieの情報を取得する
	static getCookie({n}) {
		//window.alert('COOKIE_'+document.cookie);
		n = n + '=';
		let cookieList = document.cookie.split(';');
		if (cookieList[0].length > 0) {
			for (let i = 0; i < cookieList.length; i++) {
				if (cookieList[i].lastIndexOf(n) > -1) {
					return cookieList[i].substring(cookieList[i].lastIndexOf(n) + n.length, cookieList[i].length);
				}
			}
		}
		return null;
	}
//----------------------------------------------------------------
// ORGANIZE WEB STORAGE
//----------------------------------------------------------------
	// CREATE STORAGE
	//----------------------------------------------------------------
	static createWS({typ}) {
		let ws = null;
		hustle.echo(`ORDERED_STRAGE_TYPE_>${typ}`, false);
		if('localStorage' in window) {
			ws = window.localStorage;
		} else if ('sessionStorage' in window) {
			ws = window.sessionStorage;
		}
		/*if(ws !== null) {
			//IEのみ対応
			window.addEventListener('storage', this.eventWS, false);
		}*/
		return ws;
	}
	// SET DATA
	//----------------------------------------------------------------
	static setDataWS({key, vlu, ws}) {ws.setItem(key, vlu);}
	// GET VALUE
	//----------------------------------------------------------------
	static getValueWS({key, ws}) {return ws.getItem(key);}
	// REMOVE VALUE
	//----------------------------------------------------------------
	static delValueWS({key, ws}) {ws.removeItem(key);}
	// CLEAR STORAGE
	//----------------------------------------------------------------
	static clearWS({ws}) {ws.clear();}
	// GET DATA ARRAY
	//----------------------------------------------------------------
	static getListWS({ws}) {
		let r = new Array();
		for (let i = 0; i < ws.length; i++) {
			r[i] = [ws.key(i), ws.getItem(ws.key(i))];
		}
		return r;
	}
//----------------------------------------------------------------
// LOAD XML UNSYNCRONIZATION
//----------------------------------------------------------------
	// LET LOADING XML
	//----------------------------------------------------------------
	//Syntax:hustlePageUtilityClass.letLoadXML({fn, url});
	//Parameter:"fn"はオーダー元が指定の返答先メソッド
	//Parameter:"url"はXMLファイルの参照先
	//Return:なし
	//Reference:XMLファイルを読み込みを開始する。直接の返り値がないのでthenで受ける必要はない。
	static async letLoadXML({fn, url}) {
		let req = null;
		let typ = 'text/xml';//'text/plain'
		try {
			req = await this.createHTTP();
			this.openGetHTTP({fn, url, typ, req});
		} catch(e) {
			hustle.echo(`CATCH_>${e.message}`, true);
		}
	}
	// CREATTE XML HTTP REQUEST
	//----------------------------------------------------------------
	//Syntax:hustlePageUtilityClass.createHTTP();
	//Parameter:なし
	//Return:XMLHttpRequestオブジェクト
	//Reference:XMLHttpRequestオブジェクトを生成して返す。
	static createHTTP() {
		if (window.XMLHttpRequest) {
			return new XMLHttpRequest();//IE以外
		} else if (window.ActiveXObject) {
			//IE(バージョンにより異なる)
			try {
				return new ActiveXObject("Msxml2.XMLHTTP");
			} catch (e) {
				try {
					return new ActiveXObject("Microsoft.XMLHTTP");
				} catch (e) {
					throw new Error(`XML_REQUEST_HAS_NOT_CREATED.`);
				}
			}
		} else {
			throw new Error(`XML_REQUEST_HAS_NOT_CREATED.`);
		}
	}
	// OPEN HTTP REQUEST
	//----------------------------------------------------------------
	//Syntax:hustlePageUtilityClass.openGetHTTP({fn, url, req});
	//Parameter:"fn"はオーダー元が指定の返答先メソッド
	//Parameter:"url"はXMLファイルの参照先
	//Parameter:"typ"はファイルのタイプ
	//Parameter:"req"はXMLHttpRequestオブジェクト
	//Return:なし
	//Reference:XMLHttpRequestオブジェクトに非同期でXMLを読み込みを開始する。
	//static openHTTP({fn, url, req}) {
	static openGetHTTP({fn, url, typ, req}) {
		if (req) {
			//指定URLに非同期'GET'で接続
			req.open('GET', url, true);
			req.overrideMimeType(typ);
			//onreadystatechangeは、呼び込み状況毎に呼び出される。
			req.onreadystatechange = () => {
				//readyStateで読み込み終了を確認したらXMLHttpRequestオブジェクトを返す。
				if(req.readyState===4) return fn(req);
			}
			//準備後にHTTPリクエストを送信
			req.send(null);
		} else {
			throw new Error(`XML_REQUEST_HAS_NOT_OPENED.`);
		}
	}
	// PARSE DOM
	//----------------------------------------------------------------
	//Syntax:hustlePageUtilityClass.parseDOM({src}});
	//Parameter:'src'はXMLのテキストソース
	//Return:Documentオブジェクト
	//Reference:XMLやHTMLソースコードを文字列からDOMのDocumentに解釈する。
	//static parseXML(src) {
	static parseDOM({src}) {
		try {
			//hustle.echo(`ERROR_TARGET_>${src}`, true);
			let p = new window.DOMParser();
			let r = p.parseFromString(src , 'text/xml');
			if(r.getElementsByTagName('parsererror').length > 0) {
				//hustle.echo(`ERROR_>${r}_TEST_>${r.getElementsByTagName('parsererror').length}`, true);
				throw new Error(`It is not a XML TEXT file._>${r}`);
				//r instanceof XMLDocument
			}
			return r;
		} catch(e) {
			hustle.echo(`CATCH_>${e.message}`, true);
		}
	}
//----------------------------------------------------------------
// FILE API
//----------------------------------------------------------------
	// CHECK FILE API
	//----------------------------------------------------------------
	static availableFileApi() {
		// ブラウザが File API に完全に対応しているかを返す
		return (window.File && window.FileReader && window.FileList && window.Blob);
	}
	// FILE OPTIONS
	//----------------------------------------------------------------
	static fileOptions({h, t, es}) {
		//const opts = {types:[{description:'Text files',accept:{'text/plain':['.txt']},}],};
		return {types:[{description:h,accept:{t:es},}],};
	}
	// READ FILE（未完成）
	//----------------------------------------------------------------
	//Syntax:hustlePageUtilityClass.letLoadFile({fn, f, code});
	//Parameter:'fn'はオーダー元が指定の返答先メソッド
	//Parameter:'f'はFileの単一オブジェクト（Blobオブジェクトでも良い？）
	//Parameter:'code'は読み込みテキストの文字コード
	//Return:なし
	//Reference:FileReaderオブジェクトに非同期？でFileを読み込むメソッド。
	//Reference:１ファイルの読み込みを行う。
	static letLoadFile({fn, f, code}) {
		let rdr = null;
		try {
			rdr = new FileReader();
			//maruhiro 20210105 (Special Thanks for 'Sato Yutaro')
			hustle.echo(`BU_FILES_TYPE_>${f.type}_CODE_>${code}`, false);
			switch (f.type) {
				/*case 'application/json':
					break;*/
				case 'text/plain'://'.txt'
				case 'text/csv'://'.csv'
				case 'text/tab-separated-values'://'.txtと.tsv'
				case 'application/vnd.ms-excel'://'.csv'
				default://'.tsv'のファイルはtypが空で帰ってくる環境（Win/FireFox）があるので注意（20210106）
					rdr.readAsText(f, code);
			}
			if(rdr === null) throw new Error(`FAILED LOAD A FILE.`);
		} catch(e) {
			hustle.echo(`CATCH_>${e.message}`, true);
		}
		//maruhiro 20210106 (Special Thanks for 'Miguel Sanchez')
		//非同期なのでFileReaderオブジェクトにテキスト情報指定前だと先にイベントが発生する可能性がある思ったのでイベントリスナーを一番最後に持ってきた。当たり前っちゃあたりまえ。
		//rdr.addEventListener('load', e=>fn(e), false);
		rdr.addEventListener('load', fn, false);
	}
	// SAVE FILE これはまだ使えないよ。（20210503）
	// https://qiita.com/pentamania/items/ada07c45d4e5cc139c03
	//----------------------------------------------------------------
	static letSaveFile({src}) {
		let opt = {h:'Text files', t:'text/plain', es:['.txt']};
		//let h = await window.showSaveFilePicker(this.fileOptions({h:opt.h, t:opt.t, es:opt.es}));//FileSystemFileHandleオブジェクト
		this.doSaveFile({h, src});
	}
	static async doSaveFile({h, src}) {
		let w = await h.createWritable();
		await w.write(src);
		await w.close();
	}
//----------------------------------------------------------------
// DOWNLOAD FILE
// https://qiita.com/wadahiro/items/eb50ac6bbe2e18cf8813
//----------------------------------------------------------------
	//Syntax:hustlePageUtilityClass.letDownload({src, ps, obj});
	//Parameter:'src'はダウンロードするコンテンツソース
	//Parameter:'ps'はパラメータを格納したオブジェクト
	//Parameter:'ps.bom'はBOM付きにするかの真偽値
	//Parameter:'ps.type'はファイルタイプ指定の文字列
	//Parameter:'ps.name'はダウンロードファイル名
	//Parameter:'obj'はアンカータグエレメントオブジェクト
	//Return:なし
	//Reference:ファイルのダウンロードを開始する。直接の返り値がないのでthenで受ける必要はない。
    static async letDownload({src, ps, obj}) {
		let bom = ps.bom? new Uint8Array([0xEF, 0xBB, 0xBF]) : [];
		let blob = new Blob([bom, src], {'type':ps.type});
		obj.href = window.URL.createObjectURL(blob);
		hustle.PU.setATBT({vlu:ps.name, atr:'download', obj});
		await obj.click();
		window.URL.revokeObjectURL(obj.href);//オブジェクトURLを解放
	}
//----------------------------------------------------------------
// EXEC COPY
// https://qiita.com/simiraaaa/items/2e7478d72f365aa48356
//----------------------------------------------------------------
	static execCOPY({src}) {
		let elm = document.createElement('div');
		elm.appendChild(document.createElement('pre')).innerText = src;//textContentも可
		elm.style.position = 'fixed';
		elm.style.left = '-200%';
		document.body.appendChild(elm);
		document.getSelection().selectAllChildren(elm);
		let r = document.execCommand('copy');
		document.body.removeChild(elm);
		// trueなら実行できている、falseなら失敗か対応していないか。
		return r;
	}
//----------------------------------------------------------------
// CREATE EMAIL
// https://qiita.com/tnakagawa/items/b4a4160f13fcbcf66f83
//----------------------------------------------------------------
	static createEMAIL({src, sub, to}) {
		window.location.href = 'mailto:?to=' + encodeURIComponent(to) + '&subject=' + encodeURIComponent(sub) + '&body=' + encodeURIComponent(src);
	}
}
